
#include <pthread.h>
#define BUFSIZE 8

static int buffer[BUFSIZE];
static int bufin=0;
static int bufout=0;

static pthread_mutex_t buffer_lock= PTHREAD_MUTEX_INITIALIZER;

/* Obtener el siguiente elemento del buffer y colocarlo en *itemp */
void get_item(int *itemp)
   {
    pthread_mutex_lock(&buffer_lock);
       *itemp=buffer[bufout];
       bufout=(bufout+1) % BUFSIZE;
      // printf("Tamano de bufout: %d\n",bufin);
    pthread_mutex_unlock(&buffer_lock);
    return;
   }

/*colocar un elemento en el buffer en la posicin bufin y actualizar bufin */
void put_item(int item)
   {
    pthread_mutex_lock(&buffer_lock);
       buffer[bufin]=item;
       bufin=(bufin+1) % BUFSIZE;
      // printf("Tamano de bufin: %d\n",bufin);
    pthread_mutex_unlock(&buffer_lock);
    return;
   }

