
public class BufferCirc3 //monitor
   {
   	private final int BUFSIZE=8;
   	private int bufin;
   	private int bufout;
   	private int[] buffer;
   	public int nslots;
   	public int nitems;
   	public int producer_done;
   	
   	public BufferCirc3()
   	   {
   	   	bufin=0;
   	   	bufout=0;
   	   	buffer=new int[BUFSIZE];
   	   	nslots=8;
   	   	nitems=0;
   	   	producer_done=0;
   	   }
   	   
   	public synchronized void wait_slot_lock()
   	   {
   	   	try{	
            while (nslots<=0)
             wait();
           }catch(InterruptedException e){}   
        nslots--;   
   	   }  
   	 
   	public synchronized boolean wait_item_lock()
   	   {
   	   	try{	
   	        while((nitems<=0)&&(producer_done==0))
   	             wait();
   	       }catch(InterruptedException e){}
   	    if ((nitems<=0)&&(producer_done==1))
   	       return true;
   	    nitems--;   
   	    return false; 
   	   }  
   	
   	public synchronized void notify_slot_lock()
   	  {
   	   nslots++;
   	   notify();	
   	  }   
   	   
   	public synchronized void notify_item_lock()
   	  {
   	   nitems++;
       notify();
   	  }
   	     
   	public synchronized void put_done()
   	  {
   	   producer_done=1;
   	   notify();	
   	  }     
   	     
   	public synchronized int get_item()
   	  {
   	   int valor;
   	   valor=buffer[bufout];
   	   bufout=(bufout+1)%BUFSIZE;
   	   return valor;	
   	  }
   	
    public synchronized void put_item(int item)
      {
       buffer[bufin]=item;
       bufin=(bufin+1)%BUFSIZE;	
      }  
   }
