
public class BufferCirc
   {
   	private final int BUFSIZE=8;
   	private int bufin;
   	private int bufout;
   	private int[] buffer;
   	
   	public BufferCirc()
   	   {
   	   	bufin=0;
   	   	bufout=0;
   	   	buffer=new int[BUFSIZE];
   	   }
   	   
   	public synchronized int get_item()
   	  {
   	   int valor;
   	   valor=buffer[bufout];
   	   bufout=(bufout+1)%BUFSIZE;
   	   return valor;	
   	  }
   	  
    public synchronized void put_item(int item)
      {
       buffer[bufin]=item;
       bufin=(bufin+1)%BUFSIZE;	
      }  
   }
