#include <pthread.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include "buffer_circ.h"

#define SUMSIZE 100

int sum=0;

void put_item(int);
void get_item(int *);

void producer(void *arg1)
   {
    int i;

    for(i=1;i<=SUMSIZE;i++)
      {
       printf("Se ejecuta PRODUCER...%d\n",i);
       put_item(i*i);
       sched_yield();  // Obliga al hilo productor ceder su lugar en cada iteracin
      }
   }

void consumer(void *arg2)
   {
    int i, myitem;

    for(i=1;i<=SUMSIZE;i++)
       {
        printf("Se ejecuta CONSUMER...%d\n",i);
        get_item(&myitem);
        sum+=myitem;
        sched_yield(); // Obliga al hilo consumidor ceder su lugar en cada iteracin
       }
   }

int main(void)
   {
    pthread_t prodtid;
    pthread_t constid;
    int i, total;
 
    total=0;
    for(i=1;i<=SUMSIZE;i++)
       total+=i*i;
    printf("La suma actual debe ser %d\n",total);

    /* CREAR HILOS */
    if ( pthread_create(&constid,NULL,(void * (*)(void *))&producer,NULL))
        perror("No se pudo crear el hilo consumer...");
    else if ( pthread_create(&prodtid,NULL,(void * (*)(void *))&consumer,NULL))
        perror("No se pudo crear el hilo producer...");

    /* ESPERAR A QUE LOS HILOS TERMINEN */
    pthread_join(prodtid,NULL);
    pthread_join(constid,NULL);
    printf("Los threads produjeron la suma: %d\n",sum);
    system("PAUSE");
    exit(0);
    return 1;
   }
